/* $Id: cql4.y,v 1.2 2002/10/16 18:46:35 adam Exp $
 *  CQL grammar that is sometimes referred to as "freeform" with
 *  restrictions on use paranethesis as suggested by Alan Kent. 
 */
%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
    
typedef struct {
    char *buf;
    size_t len;
    size_t max;
} token;        
#define YYSTYPE token

#include "xcqlutil.h"

int yylex(void);    
int yyerror(char *s);

%}

%token TERM AND OR NOT EXACT ALL GE LE NE ANY PROX

%%
cqlQuery: 
   '(' cqlQuery ')'
 | searchClause
 | subQuery AND subQuery andList
 | subQuery OR subQuery orList
 | subQuery NOT subQuery notList
 | subQuery PROX subQuery proxList
 ;

andList:
   andList AND subQuery
 |
 ; 

orList:
   orList OR subQuery
 |
 ; 

notList:
   notList NOT subQuery
 |
 ; 

proxList:
   proxList PROX subQuery
 |
 ; 

subQuery:
   searchClause
 | '(' cqlQuery ')'
   ;

searchClause: 
  searchTerm
| index relation searchTerm
;

relation: 
  '=' 
| '>' 
| '<'
| GE
| LE
| NE
| EXACT 
| ALL
| ANY
;

index: 
  searchTerm
  ;

searchTerm:
  TERM
| AND
| OR
| NOT
| EXACT
| ALL
;

%%

int yyerror(char *s)
{
    puts (s);
    return 0;
}

#include "lexer.c"

int main()
{
#if YYDEBUG
    yydebug=1;
#endif
    yylval.max = 20;
    yylval.buf = malloc (yylval.max);
    
    while (!yyparse())
        ;
    return 0;
}
