/*
 * $Id: lexer.c,v 1.3 2002/10/16 18:46:35 adam Exp $
 *
 * yacc lexer for CQL.
 */

int yylex()
{
    int c;
    do
    {
        c = getchar();
        if (c == EOF)
            return 0;
        if (c == '\n')
            return 0;
    } while (isspace(c));
    yylval.len = 0;
    if (strchr("()=></:", c))
    {
        int c1;
        yylval.buf[yylval.len++] = c;
        if (c == '>')
        {
            c1 = getchar();
            if (c1 == '=')
            {
                yylval.buf[yylval.len++] = c1;
                yylval.buf[yylval.len] = 0;
                return GE;
            }
            else
                ungetc(c1, stdin);
        }
        else if (c == '<')
        {
            c1 = getchar();
            if (c1 == '=')
            {
                yylval.buf[yylval.len++] = c1;
                yylval.buf[yylval.len] = 0;
                return LE;
            }
            else if (c1 == '>')
            {
                yylval.buf[yylval.len++] = c1;
                yylval.buf[yylval.len] = 0;
                return NE;
            }
            else
                ungetc(c1, stdin);
        }
        yylval.buf[yylval.len] = 0;
        return c;
    }
    if (c == '"')
    {
        while ((c = getchar()) != EOF && c != '"')
        {
            if (c == '\\')
                c = getchar();
            yylval.buf[yylval.len++] = c;
        }
        yylval.buf[yylval.len] = 0;
    }
    else
    {
        yylval.buf[yylval.len++] = c;
        while ((c = getchar()) != EOF && !strchr(" \n()=<>/:", c))
        {
            if (c == '\\')
                c = getchar();
            yylval.buf[yylval.len++] = c;
        }
        yylval.buf[yylval.len] = 0;
#if YYDEBUG
        printf ("got %s\n", yylval.buf);
#endif
        if (c != EOF)
            ungetc(c, stdin);
        if (!strcmp(yylval.buf, "and"))
            return AND;
        if (!strcmp(yylval.buf, "or"))
            return OR;
        if (!strcmp(yylval.buf, "not"))
            return NOT;
        if (!strcmp(yylval.buf, "exact"))
            return EXACT;
        if (!strcmp(yylval.buf, "all"))
            return ALL;
        if (!strncmp(yylval.buf, "prox", 4))
            return PROX;
        if (!strcmp(yylval.buf, "any"))
            return ANY;
    }
    return TERM;
}
