/* $Id: srw-client.c,v 1.7 2002/10/16 19:10:23 adam Exp $
   Copyright (C) 2002
   Index Data Aps

This file is part of the SRW tools.

See file COPYING for details.
*/

#include <stdio.h>

#include "soapH.h"

int main (int argc, char **argv)
{
    struct soap soap;
    char *action;
    int ret;
    struct zs__srwSearchRetrieveResponse res;
    zt__cqlType query;
    xsd__integer startRecord = 1;
    xsd__integer maximumRecords = 0;
    zt__schemaRefType recordSchema = "MarcXML";
    char *service = 0;

    if (argc < 2)
    {
        printf ("usage:\n srw-client");
        printf (" <service> <start> <number> <schema>\n");
        printf ("  http://localhost:8001/bagel.indexdata.dk/gils "
                "computer 1 5 MarcXML\n");
        exit (1);
    }
    service = argv[1];

    soap_init(&soap);

    if (argc >= 3)
        query = argv[2];
    else
        query = "utah";

    if (argc >= 4)
        startRecord = atoi(argv[3]);
    
    if (argc >= 5)
        maximumRecords = atoi(argv[4]);

    if (argc >= 6)
        recordSchema = argv[5];

    ret = soap_call_zs__searchRetrieve(&soap, service, action,
                                       &query,
                                       0 /* sort */,
                                       &startRecord,
                                       &maximumRecords,
                                       &recordSchema,
                                       &res);

    if (ret == SOAP_OK)
    {
        printf ("soap_call OK\n");
        if (res.searchRetrieveResponse.diagnostics.__sizeDiagnostics > 0)
        {
            int i;
            for (i = 0; i < 
                     res.searchRetrieveResponse.diagnostics.__sizeDiagnostics;
                 i++)
            {
                int code = 
                    res.searchRetrieveResponse.diagnostics.diagnostic[i]->code;
                char *details =
                    res.searchRetrieveResponse.diagnostics.diagnostic[i]->details;
                printf ("error = %d details = %s\n",
                        code, details ? details : "");
            }
                    
        }
        else
        {
            int i;
            printf ("numberOfRecords: %d\n",
                    res.searchRetrieveResponse.numberOfRecords);
            for (i = 0; i<res.searchRetrieveResponse.records.__sizeRecords;
                 i++)
            {
                printf ("rec %d schema=%s\n", i+1,
                        res.searchRetrieveResponse.records.record[i]->recordSchema);
                puts (res.searchRetrieveResponse.records.
                      record[i]->recordData);
            }
        }
    }
    else
    {
        soap_print_fault(&soap, stderr);
    }
    soap_end(&soap);
    exit (0);
    return 0;
}

