/* $Id: zing.h,v 1.9 2002/10/16 19:10:23 adam Exp $
   Copyright (C) 2002
   Index Data Aps

This file is part of the SRW tools.

See file COPYING for details.
*/
//gsoap zs service name: ZiNG
//gsoap zs service namespace: urn:z3950:ZiNG:Service
//gsoap zs schema namespace: urn:z3950:ZiNG:Service
//gsoap zt schema namespace: urn:z3950:ZiNG:Types

typedef char *xsd__string;
typedef int xsd__integer;

typedef xsd__string zt__idType;
typedef xsd__string zt__schemaRefType;
typedef char *zt__cqlType;
typedef char *zt__sortSpecType;
typedef char *XML;

struct zt__srwRecordType {
    xsd__string recordSchema;  // zt__schemaRefType, really
    xsd__string recordData;    // xsd__string or XML
};

struct zt__records {
    int __sizeRecords;
    struct zt__srwRecordType **record;
};

struct zt__diagnosticType {
    xsd__integer code;
    xsd__string details 0;
};

struct zt__diagnostics {
    int __sizeDiagnostics;
    struct zt__diagnosticType **diagnostic;
};

struct zt__srwSearchRetrieveResponseType {
    xsd__integer numberOfRecords;
    xsd__string resultSetId 1;   // was zt__idType
    xsd__integer rsIdleTime 0;
    
    struct zt__records records 0;
    struct zt__diagnostics diagnostics 0;
};

struct zs__srwSearchRetrieveResponse {
    struct zt__srwSearchRetrieveResponseType searchRetrieveResponse;
};

int zs__searchRetrieve (
    zt__cqlType *query 0,
    zt__sortSpecType *sort 0,
    xsd__integer *startRecord 0,
    xsd__integer *maximumRecords 0,
    zt__schemaRefType *recordSchema 0,
    struct zs__srwSearchRetrieveResponse *res);
