#!/usr/bin/perl -w

use SOAP::Lite;
use Data::Dumper;

my $server='http://bagel.indexdata.dk:8001/gils';
#my $server='http://gamma:8001/localhost:9999';
#my $server='http://localhost:8001/localhost:9999';

print "Start\n";

my $soap = SOAP::Lite
   -> service('file:zing_srw_binding.wsdl')
   -> proxy($server)
   ;

   ## -> new( xmlschema => '2001')
   ## -> service('file:../gsoap/ZiNG.wsdl')

print "Search\n";

my $method = SOAP::Data->name('searchRetrieve') 
  -> attr({xmlns => 'urn:z3950:ZiNG:Service'});

my @params = (
   SOAP::Data->name(query => 'utah'),
   SOAP::Data->name(startRecord => '1'),
   SOAP::Data->name(maximumRecords => '3')
);
my $response = $soap->call($method => @params);

print "============\nDumper(response) = ", Dumper($response), "=============\n\n";


print "numberOfRecords: ", $response->valueof('/Envelope/Body/[1]/[1]/numberOfRecords'), "\n";
#foreach( ($response->valueof('//records/record')) ) {
#	print "--------------------\n";
#	print "_ = ", Dumper($_), "\n";
#	print "--------------------\n";
#	print "schema=", $_->{recordSchema}, "\n";
#	print "recordData=", $_->{recordData}, "\n";
#}

print "======\n\n";

my $recno=0;
$response->match('//records');
while (1)
{
  $recno++;
  my $dr=$response->dataof('['.$recno.']');
  last unless $dr;
  print "=== Record $recno\n";
  $r=$response->SOMof('['.$recno.']');
  print "SOM of $recno \n", Dumper($r), "\n";
  next; ##!!!
  my $fno=0;
  $r->match('//oai_marc');
  while (1)
  {
    $fno++;
    my $f=$r->SOMof('['.$fno.']');
    #print "Rec $recno Fld $fno: $f\n";
    my $vf= $f->dataof('//varfield');
    last unless ($vf);
    my $fcode=$vf->attr()->{'id'};
    if ($fcode == 99245)
    {
      print "FIELD 245!!\n";
      print Dumper($vf),"\n";
      my $sf=$f->dataof('//subfield');
      if ($sf) {
        my $sfcode=$sf->attr()->{'label'};
        print "  Subfield: $fcode:$sfcode: $sf \n";
	print Dumper($sf),"\n";
	if ($sfcode eq 'a')
	{
	  my $title=$sf->value();
	  print "title=$title\n";
	} # 245-a
      }
    } # 245
    $f=undef;
  } # field loop
} # record loop

print "bye\n";

##########################
# Heikkis extension to SOAP::SOM
package SOAP::SOM;


sub SOMof{
  my $self = shift;
  local $self->{_current} = $self->{_current};
  $self->match(shift) if @_;
  return undef unless  ($self->{_current});
  return SOAP::SOM->new($self->current);
}













