#!/usr/bin/perl -w

use SOAP::Lite;
use Data::Dumper;

my $server='http://bagel.indexdata.dk:8001/gils';
#my $server='http://gamma:8001/localhost:9999';
#my $server='http://localhost:8001/localhost:9999';

print "Start\n";

my $soap = SOAP::Lite
   -> service('file:zing_srw_binding.wsdl')
   -> proxy($server)
   ;

   ## -> new( xmlschema => '2001')
   ## -> service('file:../gsoap/ZiNG.wsdl')

print "Search\n";

my $method = SOAP::Data->name('searchRetrieve') 
  -> attr({xmlns => 'urn:z3950:ZiNG:Service'});

my @params = (
   SOAP::Data->name(query => 'utah'),
   SOAP::Data->name(startRecord => '1'),
   SOAP::Data->name(maximumRecords => '3')
);
my $response = $soap->call($method => @params);

#print "============\nDumper(response) = ", Dumper($response), "=============\n\n";


print "numberOfRecords: ", $response->valueof('/Envelope/Body/[1]/[1]/numberOfRecords'), "\n";
#foreach( ($response->valueof('//records/record')) ) {
#	print "--------------------\n";
#	print "_ = ", Dumper($_), "\n";
#	print "--------------------\n";
#	print "schema=", $_->{recordSchema}, "\n";
#	print "recordData=", $_->{recordData}, "\n";
#}

my @recs=$response->valueof('//records/record');
my $nrecs=@recs;

print "Got $nrecs records\n";

my $rn;
for($rn=1; ; $rn++ ) {
  my $rp="//records/[=$rn]";
  last unless $response->match($rp);
  #print "$rp \n";
  for ($fn=1; ;$fn++){
    my $fp="$rp/recordData/oai_marc/[$fn]";
    last unless $response->match($fp);
    my $f=$response->dataof($fp);
    my $fcode = $f->attr()->{'id'};
    next unless $fcode==245;
    print "field $fp\n";
    my $fdata = $response->dataof("$fp");
    print "  fcode=$fcode fdata=$fdata \n";
    print Dumper($fdata);
    my $sf= $response->dataof("$fp/subfield");
    print "sf=$sf\n";
  }
} # record loop


