#!/usr/bin/perl -w

use SOAP::Lite;

my $soap = SOAP::Lite
   -> service('file:zing_srw_binding.wsdl')
   -> proxy('http://indexdata.dk:8001/marc');

my $method = SOAP::Data->name('searchRetrieve') 
  -> attr({xmlns => 'urn:z3950:ZiNG:Service'});

my @params = (
   SOAP::Data->name(query => 'titleString = "computer"'),
   SOAP::Data->name(startRecord => '1'),
   SOAP::Data->name(maximumRecords => '2'));

my $response = $soap->call($method => @params);

if ($response->match('//diagnostic')) {
	print "Error(s):\n";
	foreach($response->valueof('//diagnostics/diagnostic')) {
		print " code=", $_->{code};
		print ", details=", $_->{details}, "\n";
	}
} else {
	print "Hits: ", $response->valueof('//numberOfRecords'), "\n";
	foreach($response->valueof('//records/record')) {
		print "schema=", $_->{recordSchema}, "\n";
		print "recordData=", $_->{recordData}, "\n";
	}
}
